#pragma once
#include <iostream>
#include "pwt_checkinput.h"

namespace faudes {

bool IsAutomaton(Generator g) {
	
	unsigned int x, y, transMax;
	
	x = g.Size();
	y = g.AlphabetSize();
	transMax = x * y;

	if (g.TransRelSize() == transMax) {
	
		return true;
	}
	
	return false;
}

Generator CheckInputProps(Generator g) {

	Generator res1, res2;
	
	if (!(IsDeterministic(g))) {
	
		Deterministic(g, res1);
	}
	else {
	
		res1 = g;
	}
	
	StateMin(res1, res2);	
	
	if (!(IsAutomaton(res2))) {
	
		Automaton(res2);
	}
	
	return res2;
}
}
