#pragma once
#include <iostream>
#include <list>
#include "pwt_klimapolak.h"

namespace faudes {

bool IsPiecewiseTestable_KlimaPolak(Generator g) {

	g = CheckInputProps(g);

	AdjacencyMatrix m(g);
	AdjacencyList adj(m);
	
	if (adj.IsAcyclic() == false) {
	
		return false;	
	}
	
	StateSet::Iterator st_it;
	EventSet::Iterator ev_it1;
	EventSet::Iterator ev_it2;
	int i;
	int size = g.Size();
	const TransSet& trans = g.TransRel();
	TransSet::Iterator trans_it;
	Idx a, b;
	
	for (st_it = g.StatesBegin(); st_it != g.StatesEnd(); st_it++) {
	
		for (ev_it1 = g.AlphabetBegin(); ev_it1 != g.AlphabetEnd(); ev_it1++) {
		
			for (ev_it2 = g.AlphabetBegin(); ev_it2 != g.AlphabetEnd(); ev_it2++) {
					
				trans_it = trans.Begin(*st_it, *ev_it1);
				a = (*trans_it).X2;
				trans_it = trans.Begin(*st_it, *ev_it2);
				b = (*trans_it).X2;
					
				for (i = 0; i < size; i++) {
					
					trans_it = trans.Begin(a, *ev_it1);
					a = (*trans_it).X2;
					trans_it = trans.Begin(a, *ev_it2);
					a = (*trans_it).X2;
							
					trans_it = trans.Begin(b, *ev_it1);
					b = (*trans_it).X2;
					trans_it = trans.Begin(b, *ev_it2);
					b = (*trans_it).X2;		
				}
					
				if (a != b) {
					
					return false;
				}
			}		
		}	
	}
	
	return true;
}
}
