/** 

@file pwt_interface.i 

SWIG interface for piecewise testability plugin.

See the luabindings README for more documentation. 
 
**/


/*
**************************************************
**************************************************
**************************************************

Piecewise testability interface preface

**************************************************
**************************************************
**************************************************
*/

// Set SWIG module name
// Note: must match libFAUDES plugin name
%module pwtestability


// Indicate plugin to rti function definitions
#ifndef SwigModule
#define SwigModule "SwigPWTestability"
#endif

// Load std faudes interface
%include "faudesmodule.i"

// Extra Lua functions: copy to faudes name space
%luacode {
-- Copy pwtestability to faudes name space
for k,v in pairs(pwtestability) do faudes[k]=v end
}


/*
**************************************************
**************************************************
**************************************************

Piecewise testability interface: plugin function

**************************************************
**************************************************
**************************************************
*/

// Add topic to mini help system
SwigHelpTopic("PWTestability", "Piecewise Testability Plug-In");

/*

bool IsPiecewiseTestable_KlimaPolak(Generator g);

bool IsPiecewiseTestable_KlimaKuncPolak(Generator g);

bool IsPiecewiseTestable_Trahtman(Generator g);
       
SwigHelpEntry("Piecewise Testable" ,"Functions", "IsPiecewiseTestable_Trahtman(g)", "IsPiecewiseTestable_KlimaPolak(g)", "IsPiecewiseTestable_KlimaKuncPolak(g)");

*/

// Include rti generated functioninterface 
#if SwigModule=="SwigPWTestability"
%include "../../../include/rtiautoload.i"
#endif
